#include "StdAfx.h"
#include "WASGetTalkName.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"

CWASGetTalkName::CWASGetTalkName(CWASActor *pActor)
	: CWASCommand(pActor)
{
}

CWASGetTalkName::~CWASGetTalkName(void)
{
}

void CWASGetTalkName::ExecuteAsync()
{
	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}	

	USES_UTF8_CONVERSION;

	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/user/GetTalkname.php");

	m_httpFacade.session().SetURL( W2U8(strURL.c_str()), pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);
	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().AddBodyVariable("empids", W2U8(m_strEmpIDs.c_str()));

	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);

}
bool CWASGetTalkName::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	if(pDom == NULL)
		return false;	

	nfc::IIkXMLNode* pNode = pDom->GetdocumentElement()->selectSingleNode("nodes");
	if (pNode == NULL)
	{
		m_strWasErrMsg += _T("˻ Ϳ \" <nodes>\"  ã  ϴ.");
		return false;
	}

	nfc::IIkXMLNodeList *pList = pNode->selectNodes("node");	
	nfc::IIkXMLAttribute* pAttr;
	USES_UTF8_CONVERSION;
	m_listTalknameData.clear();

	for (int i = 0; i < pList->Getlength(); i++)
	{	
		NT_TALKNAME_DATA sTalknameData;
		pNode = pList->Getitem(i);
		GT_ASSERT(pNode);

		if (NULL == (pAttr = pNode->getAttribute("user_id")))// ʼ
			continue;
		
		sTalknameData.strUserID = U82W(pAttr->Gettext().c_str());		

		if (NULL != (pAttr = pNode->getAttribute("talk_nm")))
			sTalknameData.strUserNick = U82W(pAttr->Gettext().c_str());

		m_listTalknameData.push_back(sTalknameData);
	}

	return true;

}




// override in drived class
void CWASGetTalkName::OnWasResponse(trid_t trid,
									   bool bSuccess,
									   int /*nWinINetErrorCode*/, 
									   int /*nHttpResponseCode*/, 
									   LPCSTR /*szWasResCodeInHeader*/, 
									   LPCSTR szWasResCodeInXml,
									   nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	for (; it != observers.end(); ++it)
		if((*it)->OnGTWASActor_ResponseGetTalkName(m_pActor, GetID(), m_eError, m_listTalknameData) == false)
			break;

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}


void CWASGetTalkName::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();	

	for (; it != observers.end(); ++it)
		if((*it)->OnGTWASActor_ResponseGetTalkName(m_pActor, GetID(), m_eError, m_listTalknameData) == false)
			break;

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
